Subject: Re: bug#32605: [w64] (random) never returns negative

From: Eli Zaretskii <[email-masked]>
Date: Sat, 14 Aug 2021 14:33:00 +0300

> From: Andy Moreton <[email-masked]>
> Date: Sat, 14 Aug 2021 12:06:00 +0100
> 
> >> I'm not an expert on random numbers either, and your efforts are not an
> >> annoyance, but I am puzzled why you so strongly prize performance over
> >> correctness in this instance.
> >
> > Because I have no idea how important the "correctness" part is, or
> > why.  OTOH, this stuff, when used, tends to be in the inner loops, so
> > performance matters.
> 
> I doubt anyone expects cryptographic quality randomness or any given
> statistical distribution from such a general purpose routine, but they
> have a reasonable expectation that the results from 'get_random' do not
> have stuck bits that are always non-random.
> 
> In which case perhaps the solution is to change the RAND_BITS logic
> in sysdep.c on Windows to override the RAND_BITS definition:
> 
> +   #ifdef WINDOWSNT
> +   /* Use w32.c replacement for random().  */
> +   # define RAND_BITS 15
> +   #endif
> 
>     #ifndef RAND_BITS
>     # ifdef HAVE_RANDOM
>     #  define RAND_BITS 31
>     # else /* !HAVE_RANDOM */
>     ...
>     #endif
> 
> ..and then in w32.c make 'random' return the 15bit value from
> 'rand_as183':

Why not keep the 30 bits we produce today on 32-bit builds?